package ctalz.comp.act;

import java.util.*;
import ctalz.mac.*;
import ctalz.util.*;

public class Return extends ActNode
{
	private StackLayout savedStack;
	private RegFile savedRegs;
	
	void addSuccs(ActNode follow)
	{
	}
	boolean hasSideEffects()
	{
		return true;
	}
	
	void coercionConvert(Program prog, List<ActNode> nodes, StackLayout stack, RegFile regs)
	{
		savedStack = stack.saveTypes();
		savedRegs = regs.copy();
		nodes.add(this);
	}
	void prologueConvert(Program prog, List<ActNode> nodes, StackLayout stack)
	{
		savedStack = savedStack.completeMissingTypes().initialPart();
		LabelType t = savedStack.types.remove(savedStack.types.size() - 1).label;
		String app = t.calculateApplyParams(nodes, savedStack, savedRegs);
		nodes.add(new Asm("ret", app));
	}
	
	public String toString()
	{
		return "(ret)";
	}
}
