package ctalz.comp.ast;

import java.util.*;
import ctalz.util.*;

public class Init
{
	Location loc;
	Expr expr;
	List<Init> array;
	
	public Init(Expr e)
	{
		loc = e.loc; expr = e;
	}
	public Init(Location l, List<Init> a)
	{
		loc = l; array = a;
	}
	
	public String toString()
	{
		if (expr != null) {
			String result = expr.toString();
			return (expr.priority() > 100 ? result : "(" + result + ")");
		} else
			return "{ " + Utilities.enumerate(array, ", ") + " }";
	}
}
