package ctalz.comp.ctype;

import ctalz.util.*;

public class ConstType extends CType
{
	public final CType base;
	
	protected ConstType(CType b)
	{
		base = b;
		constType = this;
	}
	
	public int sizeof()
	{
		return base.sizeof();
	}
	public int alignment()
	{
		return base.alignment();
	}
	
	@Override public boolean equals(Object obj)
	{
		if (!(obj instanceof ConstType))
			return false;
		return base.equals(((ConstType)obj).base);
	}
	@Override public int hashCode()
	{
		return base.hashCode() + 101;
	}
	
	protected Pair<String, String> toString(boolean isConst)
	{
		return base.toString(true);
	}
}
