package ctalz.tc.inst;

import java.io.*;
import java.util.*;
import ctalz.type.*;
import ctalz.tc.checker.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class EOFInst extends Inst
{
	public EOFInst(Location l)
	{
		super(l);
	}
	
	public void typecheck(TypeChecker tc, ListIterator<Inst> insts) throws TypeCheckException
	{
		if (tc.isReachable())
			throw new TypeCheckException(loc, "eofReachable");
	}
	
	public void writeNative(TypeChecker tc, PrintStream out)
	{
	}
	
	public String toString()
	{
		return "eof";
	}
}
