package ctalz.tc.inst;

import java.util.*;
import ctalz.tc.checker.*;
import ctalz.type.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public class InvalidSubstitutionException extends TypeCheckException
{
	public InvalidSubstitutionException(Location loc, String t, Type dummy, int had, int expected)
	{
		super(loc, "invalidSubstTypeSize", t, had, expected);
	}
	public InvalidSubstitutionException(Location loc, String t, Expr dummy, int had, int expected)
	{
		super(loc, "invalidSubstIndexSize", t, had, expected);
	}
	public InvalidSubstitutionException(Location loc, String t, TypeVar var, String type)
	{
		super(loc, "invalidSubstTypePair", t, var, Utilities.capitalize(var.range().toString()), type);
	}
}
