package ctalz.type;

import java.util.*;
import ctalz.cnstr.*;
import ctalz.util.*;

public abstract class BasicType extends Type
{
	@Override public abstract BasicType simplify(ConstraintSolver cs);
	
	public abstract Expr sizeof(ConstraintSolver cs);
	public final boolean isNull(ConstraintSolver cs)
	{
		BasicType t = this;
		while (t instanceof GuardType) {
			if (cs.isValid(((GuardType)t).cond()))
				t = ((GuardType)t).then();
			else if (cs.isUnsatisfiable(((GuardType)t).cond()))
				t = ((GuardType)t).els();
			else
				break;
		}
		Expr s = t.sizeof(cs);
		return (s != null && cs.isEquivalent(s, ConstExpr.valueOf(0)));
	}
}
