package ctalz.util;

public class UnmodifiablePair<T, S>
{
	private final T fst;
	private final S snd;
	
	public UnmodifiablePair(T f, S s)
	{
		fst = f;
		snd = s;
	}
	
	public T fst()
	{
		return fst;
	}
	public S snd()
	{
		return snd;
	}
	
	public String toString()
	{
		return "(" + fst + "," + snd + ")";
	}
}
