package ctalz.cnstr;

import java.util.*;
import ctalz.util.*;

public abstract class Prop
{
	protected abstract Collection<VarExpr> collectFreeVariables(Collection<VarExpr> set);
	
	public abstract Prop substitute(Map<VarExpr, Expr> map);
	
	protected abstract void appendForUser(StringBuilder out, int outerOp);
	protected abstract void appendForSolver(StringBuilder out);
	
	public abstract Boolean evaluate();
	public abstract boolean deepEquals(Prop prop);
	
	public final String toString()
	{
		StringBuilder result = new StringBuilder();
		appendForUser(result, 0);
		return result.toString();
	}
}
