package ctalz.comp.act;

import java.util.*;

class Substitution<K>
{
	private LinkedHashMap<K, K> map = new LinkedHashMap<K, K>();
	
	boolean put(K key, K value)
	{
		K v = map.get(key);
		if (v == value)
			return false;
		map.put(key, value);
		return true;
	}
	K get(K key)
	{
		K result = map.get(key);
		return (result == null ? key : result);
	}
	void removeKeyValue(K key)
	{
		map.remove(key);
		Collection<K> values = map.values();
		while (values.remove(key))
			;
	}
	
	public String toString()
	{
		return map.toString();
	}
}
