package ctalz.comp.ast;

import java.util.*;
import ctalz.comp.act.*;

public class Label
{
	final String name;
	final ActNode node;
	private static int nextID;
	
	public Label()
	{
		this(null);
	}
	public Label(String n)
	{
		name = n;
		node = new ctalz.comp.act.Label(name);
	}
	
	public String toString()
	{
		return "Label " + (name == null ? "<anonymous>" : name);
	}
}
