package ctalz.comp.ast;

import ctalz.util.*;

class Token
{
	int type;
	long longValue;
	double doubleValue;
	String stringValue;
	Location loc;
	String token;
	
	public Token(Location l, String k, int t)
	{
		loc = l; token = k; type = t;
	}
	public Token(Location l, String k, int t, long i)
	{
		loc = l; token = k; type = t; longValue = i;
	}
	public Token(Location l, String k, int t, double d)
	{
		loc = l; token = k; type = t; doubleValue = d;
	}
	public Token(Location l, String k, int t, String s)
	{
		loc = l; token = k; type = t; stringValue = s;
	}
}
