package ctalz.comp.ast;

import ctalz.util.*;

public class TypeQual extends Spec
{
	final Kind kind;
	
	public enum Kind
	{
		CONST, VOLATILE;
		
		public String toString() { return name().toLowerCase(); }
	}
	
	public TypeQual(Location l, Kind k)
	{
		super(l);
		kind = k;
	}
	
	public String toString()
	{
		return kind.toString();
	}
}
