package ctalz.util;

public class AssocList<K, V>
{
	private K key;
	private V value;
	private AssocList<K, V> next;
	
	public AssocList()
	{
	}
	private AssocList(K k, V v, AssocList<K, V> n)
	{
		key = k;
		value = v;
		next = n;
	}
	
	public AssocList<K, V> add(K k, V v)
	{
		return new AssocList<K, V>(k, v, this);
	}
	public V get(K k)
	{
		for (AssocList<K, V> now = this; now != null; now = now.next) {
			if (k == null ? now.key == null : k.equals(now.key))
				return now.value;
		}
		return null;
	}
	public V getEither(K k1, K k2)
	{
		for (AssocList<K, V> now = this; now != null; now = now.next) {
			if ((k1 == null ? now.key == null : k1.equals(now.key)) || 
				(k2 == null ? now.key == null : k2.equals(now.key)))
				return now.value;
		}
		return null;
	}
}
