package ctalz.util;

public class Pair<T, S>
{
	public T fst;
	public S snd;
	
	public Pair(T f, S s)
	{
		fst = f;
		snd = s;
	}
	
	public T fst()
	{
		return fst;
	}
	public <E extends T> void setFst(E val)
	{
		fst = val;
	}
	public S snd()
	{
		return snd;
	}
	public <E extends S> void setSnd(E val)
	{
		snd = val;
	}
	
	public Pair<T, S> copy()
	{
		return new Pair<T, S>(fst, snd);
	}
	public UnmodifiablePair<T, S> unmodifiablePair()
	{
		return new UnmodifiablePair<T, S>(fst, snd);
	}
	
	public String toString()
	{
		return "(" + fst + "," + snd + ")";
	}
}
